/** @file dji_gimbal.cpp
 *  @version 4.0.0
 *  @date April 2017
 *
 *  @brief Gimbal API for OSDK library
 *
 *  @Copyright (c) 2016-2017 DJI
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include "dji_gimbal.hpp"
#include "dji_vehicle.hpp"

using namespace DJI;
using namespace DJI::OSDK;

DJI::OSDK::Gimbal::Gimbal(Vehicle* vehicle)
  : vehicle(vehicle)
{
}

DJI::OSDK::Gimbal::~Gimbal()
{
}

void
DJI::OSDK::Gimbal::setAngle(Gimbal::AngleData* data)
{
  vehicle->legacyLinker->send(OpenProtocolCMD::CMDSet::Control::gimbalAngle,
                               (unsigned char*)data, sizeof(Gimbal::AngleData));
}

void
DJI::OSDK::Gimbal::setSpeed(Gimbal::SpeedData* data)
{
  vehicle->legacyLinker->send(OpenProtocolCMD::CMDSet::Control::gimbalSpeed,
                              (unsigned char *) data,
                              sizeof(Gimbal::SpeedData));
}
